SystemOrganization addCategory: #'CI-Core'!
SystemOrganization addCategory: #'CI-Core-SliceSubmitter'!

ComposableModel subclass: #Authentifier
	instanceVariableNames: 'gmail passwordField passwordLabel result userField userLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-SliceSubmitter'!

!Authentifier commentStamp: '<historical>' prior: 0!
An Authentifier is a UI made for specifying username and password!

!Authentifier class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 7/4/2012 14:57'!
spec
<spec>

	^ SpecLayout composed
		add: #userLabel origin: 0@0 corner: 0@0 offsetOrigin: 0@0 offsetCorner: 200@25;
		add: #userField origin: 0@0 corner: 0@0 offsetOrigin: 0@25 offsetCorner: 300@50;
		add: #gmail origin: 0@0 corner: 0@0 offsetOrigin: 300@25 offsetCorner: 400@50;
		add: #passwordLabel origin: 0@0 corner: 0@0 offsetOrigin: 0@50 offsetCorner: 200@75;
		add: #passwordField origin: 0@0 corner: 0@0 offsetOrigin: 0@75 offsetCorner: 300@100;
		yourself! !

!Authentifier methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 14:57'!
gmail
	^ gmail! !

!Authentifier methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/4/2012 15:00'!
initialExtent

	^  (400@180)! !

!Authentifier methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/4/2012 15:05'!
initialize
	"Initialization code for Authentifier"

	super initialize.

	result := nil asValueHolder.! !

!Authentifier methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/10/2012 14:28'!
initializeDialogWindow: aWindow

	aWindow okAction: [ | user password |
		user := userField getText.
		password := passwordField getText.
		(user isEmpty or: [ password isEmpty ])
			ifFalse: [ result contents: (user -> password) ]].
		
	aWindow toolbar okButton 		
					isEventForNextFocusBlock: [:ev | ev keyString = '<tab>' ];
					isEventForPreviousFocusBlock: [:ev | ev keyString = '<Shift-tab>' ].
		
	aWindow toolbar cancelButton 		
					isEventForNextFocusBlock: [:ev | ev keyString = '<tab>' ];
					isEventForPreviousFocusBlock: [:ev | ev keyString = '<Shift-tab>' ].	
		
	self focusOrder
		add: userField;
		add: passwordField;
		add: aWindow toolbar.! !

!Authentifier methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/10/2012 14:26'!
initializeWidgets 

	self instantiateModels: #(
		userLabel 			LabelModel
		userField 			TextInputFieldModel
		gmail 				LabelModel
		passwordLabel 	LabelModel
		passwordField 		TextInputFieldModel ).
				
	userLabel text: 'Username:'.
	userField 
		entryCompletion: nil;
		autoAccept: true;
		isEventForNextFocusBlock: [:ev | ev keyString = '<tab>' ];
		isEventForPreviousFocusBlock: [:ev | ev keyString = '<Shift-tab>' ];
		ghostText: 'username'.
		
	gmail text: '@gmail.com'.
	passwordLabel text: 'Password:'.
	passwordField
		autoAccept: true; 
		ghostText: 'password';
		entryCompletion: nil;
		isEventForNextFocusBlock: [:ev | ev keyString = '<tab>' ];
		isEventForPreviousFocusBlock: [:ev | ev keyString = '<Shift-tab>' ];
		beEncrypted.! !

!Authentifier methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 14:57'!
passwordField
	^ passwordField! !

!Authentifier methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 14:57'!
passwordLabel
	^ passwordLabel! !

!Authentifier methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/4/2012 15:04'!
result

	^ result contents! !

!Authentifier methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/4/2012 15:51'!
title

	^ 'Enter username and password'! !

!Authentifier methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 14:57'!
userField
	^ userField! !

!Authentifier methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 14:57'!
userLabel
	^ userLabel! !

ComposableModel subclass: #IssueCreator
	instanceVariableNames: 'description issue title type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-SliceSubmitter'!

!IssueCreator commentStamp: '<historical>' prior: 0!
An IssueCreator is a UI to create a Google Issue Tracker entry!

!IssueCreator class methodsFor: 'spec' stamp: 'BenjaminVanRyseghem 7/4/2012 15:47'!
spec
<spec>

	^ SpecLayout composed
		newColumn: [:c | 
			c 
				newRow: [:r | r 
								add: #issueTitle;
								add: #type width: 150 ] height: 30;
				add: #description ];
		yourself! !

!IssueCreator methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/6/2012 16:23'!
cancelled

	^ self window 
		ifNil: [ true ]
		ifNotNil: [:w | w cancelled ]! !

!IssueCreator methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/4/2012 15:59'!
createTypes

	^ #('Type-Bug' 'Type-Cleanup' 'Type-Feature')
		collect: [:e | DropListItem named: e do: []].! !

!IssueCreator methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 15:42'!
description
	^ description! !

!IssueCreator methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 17:13'!
initialExtent 

	^ 800@500! !

!IssueCreator methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/4/2012 15:58'!
initialize
	"Initialization code for IssueCreator"

	issue := nil asValueHolder.
	super initialize.! !

!IssueCreator methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/10/2012 14:34'!
initializeDialogWindow: aWindow

	aWindow okAction: [
		description accept.
		self issue ifNotNil: [:i || t desc |
			t := title getText.
			desc := description getText asString.
			(t notEmpty and: [ desc notEmpty])
				ifTrue: [
					self issue 
						labels: { type selectedItem label. 'Milestone-', SystemVersion current majorMinor };
						title: t;
						description: desc ]]].
			
	self focusOrder
		add: title;
		add: type;
		add: description;
		add: aWindow toolbar
				
	! !

!IssueCreator methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/10/2012 14:36'!
initializeWidgets 

	self instantiateModels: #(
		title 			TextInputFieldModel
		description 	TextModel 
		type 			DropListModel ).
					
	title 
		ghostText: 'Title';
		autoAccept: true;
		isEventForNextFocusBlock: [:ev | ev keyString = '<tab>' ];
		isEventForPreviousFocusBlock: [:ev | ev keyString = '<Shift-tab>' ];
		entryCompletion: nil.
		
	type 
		items: self createTypes;
		isEventForNextFocusBlock: [:ev | ev keyString = '<tab>' ];
		isEventForPreviousFocusBlock: [:ev | ev keyString = '<Shift-tab>' ].
	
	description 
		text: 'ENTER DESCRIPTION HERE';
		readSelectionBlock: [ (0 to: 22) ];
		acceptBlock: [ description readSelectionBlock: [ (1 to: 0) ]]! !

!IssueCreator methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/4/2012 15:55'!
issue

	^ issue contents! !

!IssueCreator methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/4/2012 15:55'!
issue: anIssue

	issue contents: anIssue! !

!IssueCreator methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 15:43'!
issueTitle
	^ title! !

!IssueCreator methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/4/2012 15:51'!
title

	^ 'Issue Creator'! !

!IssueCreator methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 15:42'!
type
	^ type! !

ComposableModel subclass: #MorphEmbedder
	instanceVariableNames: 'morph container title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-SliceSubmitter'!

!MorphEmbedder commentStamp: '<historical>' prior: 0!
A MorphEmbedder is a Spec model which embed a morph into a window!

!MorphEmbedder class methodsFor: 'spec' stamp: 'BenjaminVanRyseghem 7/6/2012 15:54'!
spec
<spec>

	^ SpecLayout composed
		add: #container;
		yourself! !

!MorphEmbedder methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/6/2012 16:04'!
container

	^container ifNil: [ container :=  PanelMorph new
										color: Color red;
										vResizing: #spaceFill;
										hResizing: #spaceFill
										yourself ]! !

!MorphEmbedder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 17:16'!
initialExtent 

	^ 800@500! !

!MorphEmbedder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/6/2012 16:21'!
initialize
	"Initialization code for ChangesViewer"

	morph := nil asValueHolder.
	title := self class title.
	super initialize.

	! !

!MorphEmbedder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/18/2012 17:16'!
initializeWidgets

	morph whenChangedDo: [:m | container := m ]! !

!MorphEmbedder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/6/2012 16:06'!
morph

	^ morph contents! !

!MorphEmbedder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 17:14'!
morph: aMorph

	morph contents: aMorph.
	aMorph 
		hResizing: #spaceFill;
		vResizing: #spaceFill! !

!MorphEmbedder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/6/2012 15:59'!
result

	^ self window 
		ifNil: [ false ]
		ifNotNil: [:w | w cancelled not ]! !

!MorphEmbedder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/6/2012 16:21'!
title

	^ title! !

!MorphEmbedder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/6/2012 16:22'!
title: aString

	title := aString.
	self updateTitle.! !

!Collection methodsFor: '*CI-Core' stamp: 'Integrator 6/21/2012 17:59'!
do: aBlock inParallel: threadCount
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Collect into a new collection like the receiver, only those elements for 
	which aBlock evaluates to true. Answer the new collection."

	| addSyncronization finishSync threadBlock  |
	
	finishSync := Semaphore forMutualExclusion.
	threadBlock := Semaphore new.
	(threadCount max: 1) timesRepeat: [ threadBlock signal ].

	self do: [:each |
				threadBlock wait.
				[ 	aBlock value: each.
					finishSync signal.
					threadBlock signal] fork].
		"consume all signals"
	self size timesRepeat: [ finishSync wait ].
	^ self! !

!Collection methodsFor: '*CI-Core' stamp: 'Integrator 6/21/2012 17:59'!
doWithIndex: aBlock inParallel: threadCount
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Collect into a new collection like the receiver, only those elements for 
	which aBlock evaluates to true. Answer the new collection."

	| addSyncronization finishSync threadBlock  |
	
	finishSync := Semaphore forMutualExclusion.
	threadBlock := Semaphore new.
	(threadCount max: 1) timesRepeat: [ threadBlock signal ].

	self doWithIndex: [:each :index |
				threadBlock wait.
				[ 	aBlock value: each value: index.
					finishSync signal.
					threadBlock signal] fork].
		"consume all signals"
	self size timesRepeat: [ finishSync wait ].
	^ self! !

!Collection methodsFor: '*CI-Core' stamp: 'Integrator 6/21/2012 17:59'!
select: aBlock inParallel: threadCount
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Collect into a new collection like the receiver, only those elements for 
	which aBlock evaluates to true. Answer the new collection."

	| addSyncronization finishSync threadBlock count addCount results|
	
	finishSync := Semaphore forMutualExclusion.
	threadBlock := Semaphore new.
	(threadCount max: 1) timesRepeat: [ threadBlock signal ].
	count := 0.
	addCount := 1.
	results := Array new: self size.
	
	^ self class streamContents: [ :stream|
		self do: [:each | |blockCount|
			threadBlock wait.
			count := count + 1.
			blockCount := count.
			[(aBlock value: each) ifTrue: [ stream nextPut: each].
				finishSync signal.
				threadBlock signal] fork].
		"consume all signals"
		count timesRepeat: [ finishSync wait ]]! !

Exception subclass: #ErrorWhileCreationException
	instanceVariableNames: 'response'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core'!

!ErrorWhileCreationException commentStamp: '<historical>' prior: 0!
An ErrorWhileCreationException is an exception raised when the creation of a new issue fails!

!ErrorWhileCreationException class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/4/2012 14:12'!
response: response

	^ self new
		response: response;
		yourself! !

!ErrorWhileCreationException methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 14:11'!
response
	^ response! !

!ErrorWhileCreationException methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 14:11'!
response: anObject
	response := anObject! !

Object subclass: #GoogleAttachment
	instanceVariableNames: 'comment contents filename issue name url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core'!

!GoogleAttachment commentStamp: '<historical>' prior: 0!
A GoogleAttachment is a representation of a google issue tracker attachment!

!GoogleAttachment class methodsFor: 'instance-creation' stamp: 'CamilloBruni 9/18/2011 18:27'!
fromURL: anURLString
	^ self basicNew
		initializeWith: anURLString;
		yourself! !

!GoogleAttachment methodsFor: 'comparing' stamp: 'CamilloBruni 9/19/2011 17:50'!
= anObject
	(anObject isKindOf: self class) 
		ifFalse: [ ^ false ].
		
	^ self issue = anObject issue and: [ self name = anObject name ]! !

!GoogleAttachment methodsFor: 'accessing' stamp: 'CamilloBruni 9/21/2011 15:26'!
comment

	^ comment! !

!GoogleAttachment methodsFor: 'accessing' stamp: 'CamilloBruni 9/21/2011 15:26'!
comment: anObject
	
	comment := anObject! !

!GoogleAttachment methodsFor: 'accessing' stamp: 'CamilloBruni 9/20/2011 16:32'!
contents
	^ contents ifNil: [ contents := (ZnEasy get: self url) contents ]! !

!GoogleAttachment methodsFor: 'accessing' stamp: 'CamilloBruni 9/25/2011 05:04'!
description
	^ '"', self filename, '" from Comment #', self comment id asString! !

!GoogleAttachment methodsFor: 'accessing' stamp: 'CamilloBruni 9/18/2011 18:47'!
filename
	^ filename! !

!GoogleAttachment methodsFor: 'comparing' stamp: 'CamilloBruni 9/19/2011 17:49'!
hash
	^ self issue hash bitXor: self name hash! !

!GoogleAttachment methodsFor: 'initialize-release' stamp: 'CamilloBruni 9/19/2011 17:22'!
initializeWith: anURLString
	super initialize.
	url := anURLString. 
	self load.! !

!GoogleAttachment methodsFor: 'testing' stamp: 'CamilloBruni 9/22/2011 09:37'!
isSource
	^ (self filename endsWith: '.st') or: [ self filename endsWith: '.cs' ].! !

!GoogleAttachment methodsFor: 'accessing' stamp: 'CamilloBruni 9/19/2011 17:41'!
issue

	^ issue! !

!GoogleAttachment methodsFor: 'accessing' stamp: 'CamilloBruni 9/19/2011 17:41'!
issue: anObject
	
	issue := anObject! !

!GoogleAttachment methodsFor: 'accessing' stamp: 'CamilloBruni 9/18/2011 18:51'!
load
	filename := ('name=[^&]+' asRegex matchesIn: url) first allButFirst: 'name=' size.! !

!GoogleAttachment methodsFor: 'printing' stamp: 'CamilloBruni 9/18/2011 18:43'!
printOn: aStream
	^ aStream print: self filename! !

!GoogleAttachment methodsFor: 'accessing' stamp: 'CamilloBruni 9/21/2011 15:34'!
published
	^ self comment published! !

!GoogleAttachment methodsFor: 'accessing' stamp: 'CamilloBruni 9/18/2011 18:50'!
url
	^ url! !

Object subclass: #GoogleIssue
	instanceVariableNames: 'attachements changeLoader comments description id labels published relatedPackages relatedTests slice state status title tracker updated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core'!

!GoogleIssue commentStamp: '<historical>' prior: 0!
A GoogleIssue is a representation of a Google Issue Tracker issue.

see <http://code.google.com/p/support/wiki/IssueTrackerAPI> for a documentation of the google issue api.!

!GoogleIssue class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 6/30/2012 12:31'!
fromXML: entryNode tracker: aTracker

	| issue |
	
	issue := self id: ((entryNode findTag: 'id') text subStrings: '/') last squeezeOutNumber.
	issue tracker: aTracker.	
	issue published: entryNode published text asDateAndTime.
	issue updated: entryNode updated text asDateAndTime.
	issue title: entryNode title text.
	
	issue description: ((GoogleIssueDescription fromXML: entryNode)
							issue: issue;
							yourself).
	
	issue labels: ((entryNode findAllTags: 'issues:label') 
							collect: [:element| element text]).
	
	^ issue! !

!GoogleIssue class methodsFor: 'instance creation' stamp: 'CamilloBruni 9/22/2011 22:51'!
id: id
	^ self basicNew
		initializeWith: id! !

!GoogleIssue methodsFor: 'comparing' stamp: 'CamilloBruni 9/19/2011 17:53'!
= anObject
	(anObject isKindOf: self class)
		ifFalse: [ ^ false ].
	
	"for now the url is enough, should be extended to check things like lables and so forth"
	^ self url = anObject url
	! !

!GoogleIssue methodsFor: 'integration-private' stamp: 'BenjaminVanRyseghem 9/21/2011 15:23'!
addComment: aMessage
	^ '<?xml version="1.0" encoding="UTF-8"?>
<entry xmlns="http://www.w3.org/2005/Atom" xmlns:issues="http://schemas.google.com/projecthosting/issues/2009">
  <content type="html">', aMessage, '</content>
  <author>
    <name>',self tracker user email,'</name>
  </author>
</entry>'! !

!GoogleIssue methodsFor: 'acessing' stamp: 'CamilloBruni 9/21/2011 17:44'!
allAttachments
	"return a list of all attachments ordered by date. oldest first.
	Note: 
		this might includes duplicates as resubmitted attachments do not overwrite old ones.
		For a unique list see GoogleIssue >> #attachemnts"
	^ attachements ifNil: [ attachements := self loadAttachments ] ! !

!GoogleIssue methodsFor: 'acessing' stamp: 'CamilloBruni 9/21/2011 15:46'!
attachments
	"return a list of unique attachments.
	Note: 
		This list only includes the latest version of an attachment.
		For a complete list see GoogleIssue >> #allAttachmnens"
	attachements ifNil: [ attachements := self loadAttachments ].
	^ attachements reversed asSet asArray
	! !

!GoogleIssue methodsFor: 'loading' stamp: 'BenjaminVanRyseghem 2/28/2012 18:42'!
attachmentsScript
	"since there is no api for accessing attachments from the google issuetracker we have to manually fetch the website and extract the attachments :)"
	
	^ (self attachments collect: [:e | '']) joinUsing: '.
	'	! !

!GoogleIssue methodsFor: 'integration' stamp: 'BenjaminVanRyseghem 7/13/2012 14:52'!
changeLoader
	^ changeLoader ifNil: [ changeLoader := UlysseTheMonkey issue: self ].! !

!GoogleIssue methodsFor: 'acessing' stamp: 'CamilloBruni 9/19/2011 18:02'!
changeSets
	^ self attachments select: [ :each| 
		(each filename endsWith: '.cs') or: [ each filename endsWith: '.st' ]]! !

!GoogleIssue methodsFor: 'acessing' stamp: 'CamilloBruni 9/22/2011 18:03'!
changed
	^ self lastComment updated! !

!GoogleIssue methodsFor: 'integration' stamp: 'BenjaminVanRyseghem 7/2/2012 15:53'!
checkedInLabel

	^ {GoogleIssueTracker checkedInLabel , Smalltalk lastUpdateString squeezeOutNumber asString}! !

!GoogleIssue methodsFor: 'acessing' stamp: 'MonkeyGalactikalIntegrator 6/29/2012 17:39'!
commentById: anInteger
	^ self comments detect: [ :comment| comment id = anInteger ]! !

!GoogleIssue methodsFor: 'acessing' stamp: 'BenjaminVanRyseghem 3/26/2012 16:38'!
comments
	"return a list of GoogleIssueComment for this issue"
	^ comments ifNil: [ comments := {self description}, self loadComments ].! !

!GoogleIssue methodsFor: 'integration-private' stamp: 'MonkeyGalactikalIntegrator 6/29/2012 17:30'!
commentsUrl

	^ self url:  '/issues/', id asString, '/comments/full'! !

!GoogleIssue methodsFor: 'acessing' stamp: 'BenjaminVanRyseghem 3/26/2012 16:38'!
description
	^ description! !

!GoogleIssue methodsFor: 'acessing' stamp: 'Integrator 6/21/2012 17:52'!
description: aStringOrDescription
	description := aStringOrDescription asGoogleIssueDescription.
	description title: self title.
	description author: (self tracker ifNil: [ nil ] ifNotNil: [:t | t user ]).! !

!GoogleIssue methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 9/26/2011 18:41'!
dirtyPackagesTests
	"I should be changed to be able to detect the changes without having to load the cs"
					
	| categories classes |		
					
	categories := MCWorkingCopy allManagers 
						select: [ :each | each modified ] 
						thenCollect: [:each| each package name ].
						
	categories := categories reject: [:e | e = 'KernelTests' ].
	
	classes := self class environment allClasses 
						select: [:class | 
							categories anySatisfy: [:name | 
								class category beginsWith: name ]].
						
	^ classes select: [:e | 
			(e inheritsFrom: TestCase) and: [ e isAbstract not ]].! !

!GoogleIssue methodsFor: 'integration' stamp: 'BenjaminVanRyseghem 9/25/2011 17:23'!
ensureFix
	
	"check whether this issue has a loadable source, either an attached .cs or .st file or a SLICE"
	
	self hasFix 
		ifFalse: [ self errorNoSources ]! !

!GoogleIssue methodsFor: 'integration' stamp: 'BenjaminVanRyseghem 6/29/2012 15:17'!
errorNoSources
	"set the status of the issue to NoSourcesAvailable"
	
	self status: PharoTrackerLabels noSourcesAvailable.
	^ self submitStatusChange: (String streamContents: [ :stream| 
				stream << 'This Issue has been checked by Ulysse the Monkey, but no sources are available'; lf; lf.
				stream << 'Someone should have a look either to check the validity of the source or to report a strange behavior of a crazy monkey.']).! !

!GoogleIssue methodsFor: 'integration' stamp: 'BenjaminVanRyseghem 6/29/2012 15:17'!
errorNoSources: aMessageString
	"set the status of the issue to NoSourcesAvailable"
	
	self status: PharoTrackerLabels noSourcesAvailable.
	^ self submitStatusChange: (String streamContents: [ :stream| 
				stream << 'This Issue has been checked by Ulysse the Monkey, but no sources are available:'; lf; lf.
				stream << aMessageString]).! !

!GoogleIssue methodsFor: 'integration' stamp: 'BenjaminVanRyseghem 6/30/2012 16:53'!
failingTest: aMessageString
	"set the status of the issue to WorkNeeded and post a message"
	
	self status: PharoTrackerLabels testFailure.
	
	^ self submitStatusChange: aMessageString.
	! !

!GoogleIssue methodsFor: 'integration' stamp: 'BenjaminVanRyseghem 7/2/2012 15:53'!
fixToInclude
	"set the status of the issue to FixToInclude"

	self status: PharoTrackerLabels issueChecked.
	self labels: self checkedInLabel.
	^ self submitStatusChange: 'This Issue has been checked by Ulysse the Monkey'! !

!GoogleIssue methodsFor: 'integration' stamp: 'BenjaminVanRyseghem 7/2/2012 15:53'!
fixToInclude: aString
 
	"set the status of the issue to FixToInclude"
	self status: PharoTrackerLabels issueChecked.
	self labels: self checkedInLabel.
	^ self submitStatusChange: 'This Issue has been checked by Ulysse the Monkey
	
', aString.! !

!GoogleIssue methodsFor: 'testing' stamp: 'CamilloBruni 9/18/2011 20:32'!
hasAttachment
	^ self attachments isEmpty not! !

!GoogleIssue methodsFor: 'testing' stamp: 'CamilloBruni 9/19/2011 18:02'!
hasChangeSet
	^ self attachments anySatisfy: [ :each| 
		(each filename endsWith: '.cs') or: [ each filename endsWith: '.st' ]].! !

!GoogleIssue methodsFor: 'testing' stamp: 'CamilloBruni 9/22/2011 16:28'!
hasFix
	^ self hasSlice or: [ self hasChangeSet ].! !

!GoogleIssue methodsFor: 'testing' stamp: 'CamilloBruni 9/18/2011 20:38'!
hasSlice
	"return whether this issue has a corresponding slice in the pharo inbox"
	^ self slice isNil not! !

!GoogleIssue methodsFor: 'checking' stamp: 'CamilloBruni 9/22/2011 18:16'!
hasToBeChecked
	|date newestComment|
	
	self hasFix ifFalse: [ ^ false ].
	
	self flag: 'uuugly hardcoding of the user...'.
	(self newestComment author name == 'pharo.ulysse') ifTrue: [ ^ false ].
	
	newestComment := self newestCommentFrom: 'pharo.ulysse'.
	newestComment ifNil: [ ^ true ].
	
	date := self hasSlice 
		ifTrue: [ self slice date ]
		ifFalse: [ 
			(self changeSets detectMax: [ :each| each published]) published ].

	^ date > newestComment updated! !

!GoogleIssue methodsFor: 'comparing' stamp: 'CamilloBruni 9/19/2011 17:53'!
hash
	^ self url hash! !

!GoogleIssue methodsFor: 'acessing' stamp: 'CamilloBruni 9/18/2011 20:38'!
id
	"a unique id to identify a google issue"
	^ id! !

!GoogleIssue methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 9/26/2011 18:36'!
impactedPackagesTests
			
	| categories classes |
	categories := self relatedPackages.
	
	classes := self class environment allClasses select: [:class | 
						categories anySatisfy: [:name | 
							class category beginsWith: name ]].
					
	^ classes select: [:e | (e inheritsFrom: TestCase) and: [ e isAbstract not ]].! !

!GoogleIssue methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/26/2012 18:12'!
initialize
	"Initialization code for GoogleIssue"

	super initialize.

	attachements := nil.
	changeLoader := nil.
	comments := nil.
	description := nil.
	id := nil.
	labels := {}.
	published := nil.
	relatedPackages := nil.
	relatedTests := nil.
	slice := nil.
	state := nil.
	status := nil.
	title := nil.
	tracker := nil.
	updated := nil.! !

!GoogleIssue methodsFor: 'initialize-release' stamp: 'CamilloBruni 8/16/2011 15:01'!
initializeWith: trackingId
	super initialize.
	id := trackingId.! !

!GoogleIssue methodsFor: 'integration' stamp: 'BenjaminVanRyseghem 3/26/2012 17:20'!
integratedInVersion: anInteger
	"set the status of the issue to ReviewNeeded and post a message"
	
	self status: #Integrated.
	^ self submitStatusChange: (String streamContents: [ :stream| 
				stream <<'Integrated in Pharo' << SystemVersion current dottedMajorMinor<< ' ' << anInteger printString; cr ;cr ; <<'Thanks' ])! !

!GoogleIssue methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 7/2/2012 16:12'!
isGreen
	"return true if all the tests of the affected package are green"
	^ (UlysseTheMonkey issue: self) isGreen! !

!GoogleIssue methodsFor: 'integration-private' stamp: 'BenjaminVanRyseghem 3/26/2012 18:08'!
issueCreateXML

	^ String streamContents: [ :s|
		self issueCreateXMLOn: s ].! !

!GoogleIssue methodsFor: 'integration-private' stamp: 'BenjaminVanRyseghem 3/26/2012 18:08'!
issueCreateXMLOn: stream

	self issueXMLHeaderOn: stream.
	self issueXMLDescriptionOn: stream.
	self issueXMLTitleOn: stream.
	self issueXMLAuthorOn: stream.
	self issueXMLStatusOn: stream.
	self issueXMLLabelsOn: stream.
	self issueXMLOwnerOn: stream.
	self issueXMLFooterOn: stream! !

!GoogleIssue methodsFor: 'integration-private' stamp: 'BenjaminVanRyseghem 3/26/2012 18:05'!
issueUrl

	^ self url: '/issues/full'! !

!GoogleIssue methodsFor: 'private-XML code' stamp: 'BenjaminVanRyseghem 3/26/2012 17:39'!
issueXMLAuthorOn: stream
	stream
		nextPutAll:
			'
		  <author>
		    <name>'.
	self xmlEscape: self tracker user email on: stream.
	stream
		nextPutAll:
			'</name>
		  </author>'! !

!GoogleIssue methodsFor: 'private-XML code' stamp: 'BenjaminVanRyseghem 7/4/2012 13:40'!
issueXMLDescription: stream
	stream nextPutAll: '<content type="html">'.
	self xmlEscape: self description content on: stream.
	stream nextPutAll: '</content>'! !

!GoogleIssue methodsFor: 'private-XML code' stamp: 'BenjaminVanRyseghem 3/26/2012 17:37'!
issueXMLDescription: aMessage on: stream
	stream nextPutAll: '<content type="html">'.
	self xmlEscape: aMessage on: stream.
	stream nextPutAll: '</content>'! !

!GoogleIssue methodsFor: 'private-XML code' stamp: 'BenjaminVanRyseghem 3/26/2012 18:10'!
issueXMLDescriptionOn: stream

	self issueXMLDescription: self description content on: stream.! !

!GoogleIssue methodsFor: 'private-XML code' stamp: 'BenjaminVanRyseghem 3/26/2012 17:44'!
issueXMLFooterOn: stream
	stream nextPutAll: '</entry>'! !

!GoogleIssue methodsFor: 'private-XML code' stamp: 'BenjaminVanRyseghem 3/26/2012 17:34'!
issueXMLHeader
	^ '<?xml version="1.0" encoding="UTF-8"?>
		<entry xmlns="http://www.w3.org/2005/Atom" xmlns:issues="http://schemas.google.com/projecthosting/issues/2009">'! !

!GoogleIssue methodsFor: 'private-XML code' stamp: 'BenjaminVanRyseghem 3/26/2012 17:37'!
issueXMLHeaderOn: stream
	stream nextPutAll: self issueXMLHeader! !

!GoogleIssue methodsFor: 'private-XML code' stamp: 'BenjaminVanRyseghem 3/26/2012 17:52'!
issueXMLLabelsOn: stream
	labels
		do: [ :e | 
			stream nextPutAll: '<issues:label>'.
			self xmlEscape: e on: stream.
			stream nextPutAll: '</issues:label>' ]! !

!GoogleIssue methodsFor: 'private-XML code' stamp: 'BenjaminVanRyseghem 3/26/2012 17:43'!
issueXMLOwnerOn: stream
	stream
		nextPutAll:
			'<issues:owner>
					<issues:username>'.
	self xmlEscape: self tracker user email on: stream.
	stream
		nextPutAll:
					'</issues:username>
		  	</issues:owner>'! !

!GoogleIssue methodsFor: 'private-XML code' stamp: 'BenjaminVanRyseghem 3/26/2012 17:41'!
issueXMLStatusOn: stream
	stream nextPutAll: '<issues:status>'.
	self xmlEscape: self status on: stream.
	stream nextPutAll: '</issues:status>'! !

!GoogleIssue methodsFor: 'private-XML code' stamp: 'BenjaminVanRyseghem 3/26/2012 17:50'!
issueXMLTitleOn: stream

	stream nextPutAll: '<title>'.
	self xmlEscape: self title on: stream.
	stream nextPutAll: '</title>'! !

!GoogleIssue methodsFor: 'private-XML code' stamp: 'BenjaminVanRyseghem 7/2/2012 15:51'!
issueXMLUpdatesOn: stream
	
	stream	nextPutAll: '<issues:updates>'.
	self issueXMLStatusOn: stream.
	self issueXMLLabelsOn: stream.
	stream nextPutAll: '</issues:updates>'! !

!GoogleIssue methodsFor: 'acessing' stamp: 'CamilloBruni 9/18/2011 20:40'!
labels
	"a list of google labels"
	^ labels! !

!GoogleIssue methodsFor: 'acessing' stamp: 'CamilloBruni 8/16/2011 15:01'!
labels: aCollection 
	labels := aCollection! !

!GoogleIssue methodsFor: 'acessing' stamp: 'CamilloBruni 9/22/2011 18:02'!
lastComment
	^ self comments detectMax: [ :comment| comment published ]! !

!GoogleIssue methodsFor: 'integration' stamp: 'CamilloBruni 12/16/2011 10:03'!
load
	"try to load this issue using the ChangeLoader which will update the tracker status accordingly"
	
	self ensureFix.
	
	^ self changeLoader load
	
	
	
	! !

!GoogleIssue methodsFor: 'integration' stamp: 'CamilloBruni 12/16/2011 10:03'!
loadAndTest
	"try to load this issue using the ChangeLoader which will update the tracker status accordingly"
	
	self ensureFix.
	
	^ self changeLoader loadAndTest.
	
	
	
	! !

!GoogleIssue methodsFor: 'loading' stamp: 'MonkeyGalactikalIntegrator 6/29/2012 17:38'!
loadAttachments
	"since there is no api for accessing attachments from the google issuetracker we have to manually fetch the website and extract the attachments :)"
	
	| soup regex attachmentLinks commentTags attachment comment|
	
	soup := GoogleIssueTracker soupClass fromString:  (self tracker get: self viewUrl) contents.
	
	"manually find the matching attachment urls.."
	regex := ('http\://', self project, '.googlecode.com/issues/attachment\?.*') asRegex.
	
	attachmentLinks := ((soup // 'a') select: [ :tag| tag size = 1])
									attribute: #href matching: regex.
	
	attachmentLinks isEmpty
		ifTrue: [ ^ Array new ]. 
	
	"find the parent comment"
	commentTags := (soup // 'div') attribute: 'id' matching: 'hc[0-9]+' asRegex.
		
	"assign attachments to issues"
	^ (Array streamContents: [ :stream|
		commentTags do: [ :commentTag|
			comment := self commentById: (commentTag id allButFirst: 2) asInteger.
			attachmentLinks 
				select: [ :link| commentTag includesTag: link] 
				thenDo: [ :link|
					stream nextPut: 
						(comment addAttachment: 
							((GoogleAttachment fromURL: link href)
										issue: self;
										yourself))]]]) sort: [ :a :b| a published <= b published]
							
	! !

!GoogleIssue methodsFor: 'loading' stamp: 'MonkeyGalactikalIntegrator 6/29/2012 17:30'!
loadComments
	|contents doc nodes |
	
	contents := (self tracker get: self commentsUrl) contents.
	
	doc := GoogleIssueTracker soupClass fromString: contents.
	
	^ ((doc findAllTags: 'entry') collect: [ :node| 
		(GoogleIssueComment fromXML: node)
			issue: self;
			yourself ]) asArray.	
	! !

!GoogleIssue methodsFor: 'loading' stamp: 'CamilloBruni 8/16/2011 18:47'!
loadRelatedPackages
	| packages testPackages|
	packages := self slice version dependencies collect: [ :dep| dep package name ].
	
	self flag: 'should also add the packages of all subclasses...'.
	
	"manually try to figure out weirdly TEST- prefixed packages"
	testPackages := OrderedCollection new.
	packages do: [ :package|
		self flag: 'there must be a cleaner way to do this...'.
		testPackages addAll: (SystemNavigation default environment organization categoriesMatching: 'Tests-', package, '*')].
	
	testPackages addAll: packages.
	
	^ testPackages asArray! !

!GoogleIssue methodsFor: 'loading' stamp: 'CamilloBruni 9/19/2011 18:10'!
loadSlice
	^ self loadSliceFrom: (Gofer new url: 'http://ss3.gemstone.com/ss/PharoInbox')! !

!GoogleIssue methodsFor: 'loading' stamp: 'MonkeyGalactikalIntegrator 12/16/2011 16:22'!
loadSliceFrom: gofer
	|match slices|
	
	match := 'SLICE-Issue-', id asString.
	slices := gofer allResolved select: [ :ref| ref name beginsWith: match].
	
	slices ifEmpty: [ ^ nil ].
	
	slices size == 1 ifTrue: [ ^ slices first ].
	
	"filter out local cache repositories"
	slices := slices reject: [ :goferReference| 
		goferReference repository isKindOf: MCCacheRepository ].
	
	" get the last version "
	^ (slices sort: [ :a :b | a versionNumber >= b versionNumber ]) first! !

!GoogleIssue methodsFor: 'loading' stamp: 'BenjaminVanRyseghem 9/26/2011 17:45'!
loadSource

	self hasSlice ifTrue: [ ^ self loadSlice ].
	self hasAttachment ifTrue: [ ^ self loadAttachments ].
	
	self error: 'Nothing to do'! !

!GoogleIssue methodsFor: 'checking' stamp: 'BenjaminVanRyseghem 3/26/2012 17:20'!
monkeyIsChecking

	self status: 'MonkeyIsChecking'.
	self submitStatusChange: 'The Monkey is currently checking this issue. Please don''t change it!!'! !

!GoogleIssue methodsFor: 'printing' stamp: 'BenjaminVanRyseghem 9/26/2011 16:01'!
name

	^ String streamContents: [:s | s << self id asString << ': ' << self title ]! !

!GoogleIssue methodsFor: 'new issue' stamp: 'BenjaminVanRyseghem 7/4/2012 13:49'!
newEntryURL

	^ self url: '/issues/full'! !

!GoogleIssue methodsFor: 'new issue' stamp: 'BenjaminVanRyseghem 7/4/2012 13:39'!
newIssueXML

	^ String streamContents: [:s | self newIssueXML: s ]! !

!GoogleIssue methodsFor: 'new issue' stamp: 'BenjaminVanRyseghem 7/4/2012 13:45'!
newIssueXML: stream

	self 
		issueXMLHeaderOn: stream;
		issueXMLTitleOn: stream;
		issueXMLDescription: stream;
		issueXMLAuthorOn: stream;
		issueXMLStatusOn: stream;
		issueXMLOwnerOn: stream;
		issueXMLLabelsOn: stream;
		issueXMLFooterOn: stream! !

!GoogleIssue methodsFor: 'acessing' stamp: 'CamilloBruni 9/22/2011 18:02'!
newestComment
	^ self comments detectMax: [ :comment| comment updated ]! !

!GoogleIssue methodsFor: 'checking' stamp: 'CamilloBruni 9/22/2011 18:05'!
newestCommentFrom: anEmailString

	| messagesFrom |
	messagesFrom := self comments select: [:comment | comment author = anEmailString ].
	^ messagesFrom detectMax: [ :comment| comment updated ]! !

!GoogleIssue methodsFor: 'integration-private' stamp: 'MonkeyGalactikalIntegrator 6/29/2012 17:35'!
postXML: anXMLString to: anUrl
	| client entity |
	"google allows committing changes only on https"
	anUrl scheme: 'https'.
	
	client := self tracker client.
	entity := ZnEntity text: anXMLString.
	entity contentType: ((ZnMimeType main: 'application' sub: 'atom+xml') setCharSetUTF8).
	client 
		url: anUrl;
		entity: entity;
		post.
	
	^ client response! !

!GoogleIssue methodsFor: 'printing' stamp: 'BenjaminVanRyseghem 7/4/2012 15:56'!
printOn: aStream
	super printOn: aStream.
	aStream << '(#' << self id asString << ': ' << self title asString << ')'! !

!GoogleIssue methodsFor: 'acessing' stamp: 'CamilloBruni 8/16/2011 14:35'!
project
	^ tracker project! !

!GoogleIssue methodsFor: 'acessing' stamp: 'CamilloBruni 8/16/2011 15:02'!
published
	^ published! !

!GoogleIssue methodsFor: 'acessing' stamp: 'CamilloBruni 8/16/2011 15:03'!
published: aDateTime
	published := aDateTime! !

!GoogleIssue methodsFor: 'acessing' stamp: 'CamilloBruni 8/16/2011 18:36'!
relatedPackages
	^ relatedPackages ifNil: [ relatedPackages := self loadRelatedPackages ].
	! !

!GoogleIssue methodsFor: 'integration' stamp: 'BenjaminVanRyseghem 6/29/2012 15:22'!
reviewNeeded: aMessageString
	"set the status of the issue to WorkNeeded and post a message"
	
	self status: PharoTrackerLabels workNeeded.
	
	^ self submitStatusChange: aMessageString.
	! !

!GoogleIssue methodsFor: 'loading' stamp: 'BenjaminVanRyseghem 2/28/2012 18:17'!
script

	self hasSlice ifTrue: [ ^ self sliceScript ].
	self hasAttachment ifTrue: [ ^ self attachmentsScript ].
	
	self error: 'Nothing to do'! !

!GoogleIssue methodsFor: 'acessing' stamp: 'CamilloBruni 8/16/2011 16:48'!
slice
	^ slice ifNil: [ slice := self loadSlice ].! !

!GoogleIssue methodsFor: 'loading' stamp: 'BenjaminVanRyseghem 2/28/2012 21:36'!
sliceScript
	| slc |
	slc := self slice.
	^ String streamContents: [:s | 
		s << 'Gofer new
	url: ' << slc repository description printString <<';' << String crlf << String tab << 'package: ' << 	slc packageName printString << ';' << String crlf << String tab << 'version: ' << slc name printString <<';' << String crlf << String tab << 'load.' ].! !

!GoogleIssue methodsFor: 'acessing' stamp: 'CamilloBruni 8/16/2011 15:02'!
state
	^ state! !

!GoogleIssue methodsFor: 'acessing' stamp: 'CamilloBruni 8/16/2011 15:02'!
status
	^ status! !

!GoogleIssue methodsFor: 'acessing' stamp: 'CamilloBruni 9/20/2011 18:13'!
status: aSataneouStatusString
	status := aSataneouStatusString! !

!GoogleIssue methodsFor: 'integration-private' stamp: 'BenjaminVanRyseghem 3/26/2012 17:22'!
statusUpdateXML: aMessage
	^ String streamContents: [ :s|
		self statusUpdateXML: aMessage on: s ].! !

!GoogleIssue methodsFor: 'integration-private' stamp: 'BenjaminVanRyseghem 7/2/2012 15:51'!
statusUpdateXML: aMessage on: stream

	self issueXMLHeaderOn: stream.
	self issueXMLDescription: aMessage on: stream.
	self issueXMLAuthorOn: stream.
	self issueXMLUpdatesOn: stream.
	self issueXMLFooterOn: stream! !

!GoogleIssue methodsFor: 'saving' stamp: 'BenjaminVanRyseghem 3/26/2012 18:23'!
submit
	
	"save an issue on the tracker"
	
	| result |
	
	id ifNotNil: [ ^  self error: 'Cannot create the same issue twice. Original issue is ', self viewUrl ].
	result := self postXML: self issueCreateXML to: self issueUrl.
	
	"set the id to prevent multiple submissions of the same issue"
	id := result location squeezeOutNumber.
	
	^ result.! !

!GoogleIssue methodsFor: 'new issue' stamp: 'BenjaminVanRyseghem 7/4/2012 14:17'!
submitAsNewEntry
	| response |
	
	response := self postXML: (self newIssueXML) to: self newEntryURL.
	response statusLine code = 201
		ifTrue: [ id := (response headers headers at: 'Location') squeezeOutNumber ]
		ifFalse: [ ErrorWhileCreationException response: response ].
		
	^ self! !

!GoogleIssue methodsFor: 'integration-private' stamp: 'BenjaminVanRyseghem 3/26/2012 18:00'!
submitStatusChange

	^ self submitStatusChange:''! !

!GoogleIssue methodsFor: 'integration-private' stamp: 'BenjaminVanRyseghem 3/26/2012 18:06'!
submitStatusChange: aMessageString
	^ self postXML: (self statusUpdateXML: aMessageString) to: self commentsUrl! !

!GoogleIssue methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 9/26/2011 18:38'!
testClassesToBeChecked

	self hasSlice ifTrue: [ ^ self impactedPackagesTests ].
	self hasAttachment ifTrue: [ ^ self dirtyPackagesTests ].

	^ self error: 'Why are you loading me ?'! !

!GoogleIssue methodsFor: 'acessing' stamp: 'CamilloBruni 8/16/2011 15:02'!
title
	^ title! !

!GoogleIssue methodsFor: 'acessing' stamp: 'BenjaminVanRyseghem 3/26/2012 16:49'!
title: aString
	title := aString.
	description ifNotNil: [
		description title: self title ].! !

!GoogleIssue methodsFor: 'acessing' stamp: 'CamilloBruni 8/16/2011 15:01'!
tracker
	^ tracker! !

!GoogleIssue methodsFor: 'acessing' stamp: 'CamilloBruni 8/16/2011 15:01'!
tracker: aTracker
	tracker := aTracker! !

!GoogleIssue methodsFor: 'acessing' stamp: 'CamilloBruni 8/16/2011 15:03'!
updated
	^ updated! !

!GoogleIssue methodsFor: 'acessing' stamp: 'CamilloBruni 8/16/2011 15:03'!
updated: aDateTime
	updated := aDateTime! !

!GoogleIssue methodsFor: 'acessing' stamp: 'CamilloBruni 9/20/2011 16:53'!
url
	^ self url: ''! !

!GoogleIssue methodsFor: 'acessing' stamp: 'MonkeyGalactikalIntegrator 6/29/2012 17:45'!
url: aSubPath
	| url |
	url :=  'http://code.google.com/feeds/issues/p' asZnUrl.
	url 
		addPathSegment: self project;
		addPathSegments: (($/ split: aSubPath) reject: [ :each| each isEmpty ]).
	^ url! !

!GoogleIssue methodsFor: 'acessing' stamp: 'CamilloBruni 9/18/2011 18:19'!
viewUrl
	^ 'http://code.google.com/p/', self project, '/issues/detail?id=', id asString! !

!GoogleIssue methodsFor: 'integration-private' stamp: 'BenjaminVanRyseghem 3/26/2012 17:25'!
xmlEscape: aString on: stream
	"a poor man's convert... :/"
	| map |
	map := Dictionary newFromPairs: #(
				$" '&quot;' 
				$' '&apos;' 
				$< '&lt;' 
				$> '&gt;' 
				$& '&amp;').
	
	aString do: [ :c|
		map 
			at: c 
			ifPresent: [ :mapping| stream nextPutAll: mapping ] 
			ifAbsent: [ stream nextPut: c]]. ! !

Object subclass: #GoogleIssueComment
	instanceVariableNames: 'attachments author content id issue published title updated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core'!

!GoogleIssueComment commentStamp: '<historical>' prior: 0!
A GoogleIssueComment is a representation of a Google Issue Tracker issue's comment!

!GoogleIssueComment class methodsFor: 'instance creation' stamp: 'CamilloBruni 9/22/2011 22:08'!
fromXML: entryNode

	| comment idString |
	
	idString := entryNode id text.
	
	comment := self id: (idString copyFrom: (idString lastIndexOf: $/) + 1 to: idString size) asInteger. 
	
	comment published: entryNode published text asDateAndTime.
	comment updated: entryNode updated text asDateAndTime.
	comment title: entryNode title text trimBoth.
	comment content: entryNode content text trimBoth.
	comment author: (GoogleUser fromXML: entryNode author).
	
	^ comment! !

!GoogleIssueComment class methodsFor: 'instance creation' stamp: 'CamilloBruni 9/22/2011 22:08'!
id: id
	^ self basicNew
		initializeWith: id! !

!GoogleIssueComment methodsFor: 'accessing' stamp: 'CamilloBruni 9/21/2011 15:37'!
addAttachment: anAttachment
	
	attachments add: anAttachment.
	anAttachment comment: self.
	
	^ anAttachment! !

!GoogleIssueComment methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 3/26/2012 17:04'!
asComment
	^ self! !

!GoogleIssueComment methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 3/26/2012 17:05'!
asDescription
	GoogleIssueDescription adoptInstance: self.
	^ self ! !

!GoogleIssueComment methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 3/26/2012 16:40'!
asGoogleIssueComment
	^ self! !

!GoogleIssueComment methodsFor: 'accessing' stamp: 'CamilloBruni 9/21/2011 02:01'!
attachments

	^ attachments! !

!GoogleIssueComment methodsFor: 'accessing' stamp: 'CamilloBruni 9/21/2011 02:01'!
attachments: anObject
	
	attachments := anObject! !

!GoogleIssueComment methodsFor: 'acessing' stamp: 'CamilloBruni 8/16/2011 15:29'!
author
	^ author! !

!GoogleIssueComment methodsFor: 'acessing' stamp: 'CamilloBruni 8/16/2011 15:29'!
author: anAuthor
	author := anAuthor! !

!GoogleIssueComment methodsFor: 'acessing' stamp: 'CamilloBruni 8/16/2011 15:29'!
content
	^ content! !

!GoogleIssueComment methodsFor: 'acessing' stamp: 'CamilloBruni 8/16/2011 15:29'!
content: aString
	content := aString! !

!GoogleIssueComment methodsFor: 'acessing' stamp: 'CamilloBruni 8/16/2011 15:28'!
id
	^ id! !

!GoogleIssueComment methodsFor: 'initialize-release' stamp: 'CamilloBruni 9/21/2011 15:36'!
initializeWith: anIssueId
	super initialize.
	id := anIssueId.
	attachments := OrderedCollection new.! !

!GoogleIssueComment methodsFor: 'acessing' stamp: 'CamilloBruni 8/16/2011 15:28'!
issue
	^ issue! !

!GoogleIssueComment methodsFor: 'acessing' stamp: 'CamilloBruni 9/21/2011 15:39'!
issue: anIssue

	issue := anIssue! !

!GoogleIssueComment methodsFor: 'acessing' stamp: 'CamilloBruni 8/16/2011 15:28'!
published
	^ published! !

!GoogleIssueComment methodsFor: 'acessing' stamp: 'CamilloBruni 9/21/2011 15:41'!
published: aDateTime

	published := aDateTime! !

!GoogleIssueComment methodsFor: 'acessing' stamp: 'CamilloBruni 8/16/2011 15:28'!
title
	^ title! !

!GoogleIssueComment methodsFor: 'acessing' stamp: 'CamilloBruni 9/21/2011 15:39'!
title: aString

	title := aString! !

!GoogleIssueComment methodsFor: 'acessing' stamp: 'CamilloBruni 8/16/2011 15:28'!
updated
	^ updated! !

!GoogleIssueComment methodsFor: 'acessing' stamp: 'CamilloBruni 9/21/2011 15:41'!
updated: aDateTime

	updated := aDateTime! !

GoogleIssueComment subclass: #GoogleIssueDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core'!

!GoogleIssueDescription commentStamp: '<historical>' prior: 0!
A GoogleIssueDescription is a representation of a Google Issue Tracker issue first comment (the Google API have a special name for it)!

!GoogleIssueDescription methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 3/26/2012 17:05'!
asComment
	GoogleIssueComment adoptInstance: self.
	^ self ! !

!GoogleIssueDescription methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 3/26/2012 17:04'!
asDescription
	^ self! !

!GoogleIssueDescription methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 3/26/2012 16:57'!
asGoogleIssueDescription
	^ self! !

!GoogleIssueDescription methodsFor: 'acessing' stamp: 'CamilloBruni 9/22/2011 22:47'!
id
	^ 0! !

!GoogleIssueDescription methodsFor: 'initialize-release' stamp: 'CamilloBruni 9/22/2011 22:47'!
initializeWith: anIssueId
	super initializeWith: 0! !

Object subclass: #GoogleIssueTracker
	instanceVariableNames: 'authentificationToken project integrated user token'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core'!

!GoogleIssueTracker commentStamp: '<historical>' prior: 0!
self example.

IntegrationManager initialize.
IntegrationManager default summary.

see <http://code.google.com/p/support/wiki/IssueTrackerAPI> for a documentation of the google issue api.!

!GoogleIssueTracker class methodsFor: 'issues' stamp: 'BenjaminVanRyseghem 7/2/2012 15:03'!
checkedInLabel

	^ 'CheckedIn'! !

!GoogleIssueTracker class methodsFor: 'to be overriden' stamp: 'DamienCassou 4/27/2012 17:22'!
example
	"self example"
	| tracker issue |
	"Example usage of the issue tracker"
	Halt now: 'Evaluate step by step for a better understanding'.
	tracker := GoogleIssueTracker pharo.
	
	"give back a list of all open issues"
	tracker openIssues.
	
	issue := tracker issue: 4839 "this is an explicit testing issue".
	issue comments.

	issue hasAttachment ifTrue: [
		"give back a list of the recent attachements"
		issue attachements.
		"give back a list of all attachments (including previous versions of the same file)"
		issue allAttachments].
	
	issue hasSlice ifTrue: [
		"return a Gofer object for the slice corresponding to the issue"
		issue slice].
	
	"run the tests of all packages changed by the issues's slice"
	issue isGreen.

	"authenticate with your google account to change the issues directly from your code"
	tracker authenticate: 'yourmail@gmail.com' with: 'XXX'.

	"mark the issue ready for intergation (will update the tracker)"
	issue fixToInclude.

	"mark the issue to be review with a comment"
	issue reviewNeeded: 'Could not load the attached SLICE'.! !

!GoogleIssueTracker class methodsFor: 'instance creation' stamp: 'CamilloBruni 8/16/2011 14:22'!
for: projectName
	^ self new
		initializeWith: projectName.! !

!GoogleIssueTracker class methodsFor: 'instance creation' stamp: 'CamilloBruni 9/18/2011 04:10'!
pharo
	^ self for: 'pharo'! !

!GoogleIssueTracker methodsFor: 'login' stamp: 'CamilloBruni 9/20/2011 16:35'!
authenticate: aUserEmailAddress with: aPasswordString
	user := GoogleUser email: aUserEmailAddress.
	token := user authenticateService: self googleServiceName with: aPasswordString.! !

!GoogleIssueTracker methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/2/2012 15:04'!
checkedInLabel

	^ self class checkedInLabel! !

!GoogleIssueTracker methodsFor: 'private' stamp: 'CamilloBruni 9/20/2011 18:05'!
client
	|client|
	client := ZnEasy client.
	
	self isAuthenticated 
		ifTrue: [ client headerAt: 'Authorization' add: 'GoogleLogin auth="', self token id, '"'].		
	
	^ client! !

!GoogleIssueTracker methodsFor: 'issues' stamp: 'CamilloBruni 9/21/2011 01:52'!
closedIssues

	^ self issuesWithParams: 'can=closed'.
	! !

!GoogleIssueTracker methodsFor: 'private' stamp: 'CamilloBruni 9/20/2011 18:06'!
get: anUrl
	| client |
	
	client := self client.
	client url: anUrl.
	
	^ client get; response! !

!GoogleIssueTracker methodsFor: 'accessing' stamp: 'CamilloBruni 9/20/2011 16:01'!
googleServiceName
	"identifies the issue tracker. Generally the prefix of the google service's domain name (http://code.google.com/...)
	see http://code.google.com/apis/gdata/faq.html#clientlogin"
	
	^ #code! !

!GoogleIssueTracker methodsFor: 'initialize-release' stamp: 'CamilloBruni 9/18/2011 04:13'!
initializeWith: name
	super initialize.
	project := name.
	integrated := Set new.! !

!GoogleIssueTracker methodsFor: 'testing' stamp: 'CamilloBruni 9/20/2011 16:38'!
isAuthenticated
	^ token isNil not! !

!GoogleIssueTracker methodsFor: 'issues' stamp: 'CamilloBruni 8/16/2011 15:24'!
issue: id
	
	^ (self issuesWithParams: 'id=', id asString) first.! !

!GoogleIssueTracker methodsFor: 'private' stamp: 'DamienCassou 5/15/2012 18:29'!
issuesFromXML: xml
	
	^ (((GoogleIssueTracker soupClass fromString: xml) findAllTags: 'entry' )
			collect: [ :node| GoogleIssue fromXML: node tracker: self]) asArray.	! !

!GoogleIssueTracker methodsFor: 'issues' stamp: 'CamilloBruni 9/21/2011 01:52'!
issuesToCheck
	
	^ self issuesWithParams: 'can=open'.! !

!GoogleIssueTracker methodsFor: 'private' stamp: 'CamilloBruni 9/20/2011 16:57'!
issuesURL
	^ 'http://code.google.com/feeds/issues/p/', project, '/issues/full?max-results=99999&'! !

!GoogleIssueTracker methodsFor: 'private' stamp: 'CamilloBruni 9/20/2011 17:01'!
issuesWithParams: urlParams
	^ self issuesFromXML: (self get: (self issuesURL, urlParams)) contents
	! !

!GoogleIssueTracker methodsFor: 'issues' stamp: 'BenjaminVanRyseghem 3/26/2012 18:12'!
newIssueNamed: aTitleString description: aString
	" create a new issue on myself.
	Example:
		| issue |
		issue := self newIssueNamed: 'foo' description: 'an issue description'.
		issue submit. "

	^ GoogleIssue new
				tracker: self;
				title: aTitleString;
				description: aString;
				status: #Accepted;
				yourself.! !

!GoogleIssueTracker methodsFor: 'issues' stamp: 'BenjaminVanRyseghem 7/2/2012 16:03'!
nextAlreadyCheckedButInAPreviousPharoVersionIssue
	"choose the next issue to check by ulysse"

	| issues nextIssue |
	"try issues which are new and unprrocessed"
	issues := self issuesWithParams: 'can=open&status=' , PharoTrackerLabels issueChecked , '&q=Milestone%3D' , SystemVersion current majorMinor.
	
	^ issues
		detect: [ :e || labels |
			labels := e labels select: [ :s | (s beginsWith: self checkedInLabel) ].
			labels ifEmpty: [ ^ e ].
			
			labels noneSatisfy: [:s | s squeezeOutNumber = Smalltalk lastUpdateString squeezeOutNumber ]]
		ifNone: [ nil ]! !

!GoogleIssueTracker methodsFor: 'issues' stamp: 'BenjaminVanRyseghem 7/2/2012 15:56'!
nextIssue
	
	"choose the next issue to check by ulysse"
	
	| issues nextIssue |
	
	"try issues which are new and unprrocessed"
	issues := self issuesWithParams: 'can=open&status=', PharoTrackerLabels reviewNeeded,'&q=Milestone%3D' , SystemVersion current majorMinor.
	issues ifEmpty: [ ^ self nextAlreadyCheckedButInAPreviousPharoVersionIssue ].
	nextIssue := issues first.
	nextIssue hasFix
		ifTrue: [ ^ nextIssue ]
		ifFalse: [ 
			nextIssue errorNoSources.
			^ self nextIssue ]! !

!GoogleIssueTracker methodsFor: 'issues' stamp: 'BenjaminVanRyseghem 6/30/2012 17:12'!
nextIssueId
	
	^ self nextIssue 
			ifNil: [ nil ] 
			ifNotNil:[ :nextIssue | nextIssue id ]! !

!GoogleIssueTracker methodsFor: 'issues' stamp: 'CamilloBruni 9/21/2011 01:49'!
openIssues
	
	^ self issuesWithParams: 'can=open'.! !

!GoogleIssueTracker methodsFor: 'accessing' stamp: 'CamilloBruni 8/16/2011 14:23'!
project
	^ project! !

!GoogleIssueTracker methodsFor: 'integration' stamp: 'BenjaminVanRyseghem 10/3/2011 17:20'!
readyForIntegrationIssues
	
	^ self issuesWithParams: 'status=FixToInclude'.! !

!GoogleIssueTracker methodsFor: 'accessing' stamp: 'CamilloBruni 9/20/2011 16:48'!
token	
	^ token! !

!GoogleIssueTracker methodsFor: 'accessing' stamp: 'CamilloBruni 9/20/2011 16:33'!
user
	^ user! !

!GoogleIssueTracker methodsFor: 'accessing' stamp: 'CamilloBruni 9/20/2011 13:17'!
viewUrl
	^ 'http://code.google.com/p/', self project! !

Object subclass: #GoogleToken
	instanceVariableNames: 'service token user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core'!

!GoogleToken commentStamp: '<historical>' prior: 0!
Used to encapsulate the password to avoid a security breach!

!GoogleToken class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 9/20/2011 15:58'!
service: aGoogleServiceName user: aUserString password: aPasswordString
	^ self new
		service: aGoogleServiceName;
		user: aUserString;
		login: aPasswordString! !

!GoogleToken methodsFor: 'private' stamp: 'CamilloBruni 9/20/2011 16:31'!
handleLoginResult: aResultString
	"parse the result returned from a google authentification request. 
	see http://code.google.com/apis/accounts/docs/AuthForInstalledApps.html#Request"
	
	| tokens |
	
	tokens := Character lf split: aResultString contents trimRight.
	tokens := tokens gather: [ :each | $= split: each ].
	tokens := Dictionary newFromPairs: tokens.
	
	token := tokens at: #Auth ifAbsent: [ Error signal: 'Invalid login' ].! !

!GoogleToken methodsFor: 'accessing' stamp: 'CamilloBruni 9/20/2011 16:48'!
id

	^ token! !

!GoogleToken methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 11/21/2011 13:17'!
login: aPasswordString
	"request a authentification token from google: see http://code.google.com/p/support/wiki/IssueTrackerAPI"
	
	| result client|
	
	client := ZnClient new 
					url: 'https://www.google.com/accounts/ClientLogin';
					yourself.
	
	client 
		formAt: #accountType put: #GOOGLE;
		formAt: #service put: self service;
		formAt: #source put: 'pharo-googleCI-1.0';
		formAt: #Email put: self user email;
		formAt: #Passwd put: aPasswordString.
	
	self handleLoginResult: client post.! !

!GoogleToken methodsFor: 'accessing' stamp: 'CamilloBruni 9/20/2011 13:23'!
service

	^ service! !

!GoogleToken methodsFor: 'accessing' stamp: 'CamilloBruni 9/20/2011 13:23'!
service: anObject
	
	service := anObject! !

!GoogleToken methodsFor: 'accessing' stamp: 'CamilloBruni 9/20/2011 13:23'!
token

	^ token! !

!GoogleToken methodsFor: 'accessing' stamp: 'CamilloBruni 9/20/2011 13:23'!
user

	^ user! !

!GoogleToken methodsFor: 'accessing' stamp: 'CamilloBruni 9/20/2011 13:23'!
user: anObject
	
	user := anObject! !

Object subclass: #GoogleUser
	instanceVariableNames: 'email'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core'!

!GoogleUser commentStamp: '<historical>' prior: 0!
A user entity needed by Google to ensure authentification!

!GoogleUser class methodsFor: 'instance creation' stamp: 'CamilloBruni 9/20/2011 13:26'!
email: email

	^ self new
		email: email;
		yourself! !

!GoogleUser class methodsFor: 'as yet unclassified' stamp: 'MonkeyGalactikalIntegrator 12/13/2011 16:46'!
fromXML: entryNode
	entryNode ifNil: [ ^ nil ].
	^ self email: (entryNode findTag: #name) text! !

!GoogleUser methodsFor: 'authentification' stamp: 'CamilloBruni 9/20/2011 16:02'!
authenticateSerivce: aGoogleServiceName with: aPasswordString
	^ GoogleToken service: aGoogleServiceName user: email password: aPasswordString! !

!GoogleUser methodsFor: 'authentification' stamp: 'CamilloBruni 9/20/2011 16:05'!
authenticateService: aGoogleServiceName with: aPasswordString
	" I create a new GoogleToken which is used for identifikation.
	aGoogleServiceName: a google service name. see http://code.google.com/apis/gdata/faq.html#clientlogin
	aPasswordString: a password for this user
	"
	
	^ GoogleToken service: aGoogleServiceName user: self password: aPasswordString! !

!GoogleUser methodsFor: 'accessing' stamp: 'CamilloBruni 9/20/2011 13:10'!
email

	^ email! !

!GoogleUser methodsFor: 'accessing' stamp: 'CamilloBruni 9/20/2011 13:10'!
email: anObject
	
	email := anObject! !

Object subclass: #PharoTrackerLabels
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core'!

!PharoTrackerLabels commentStamp: '<historical>' prior: 0!
I contain the labels for the google issue tracker entries!

!PharoTrackerLabels class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 16:38'!
accepted

	^ #Accepted! !

!PharoTrackerLabels class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/30/2012 17:13'!
issueChecked

	^ #ValidatedByTheMonkey! !

!PharoTrackerLabels class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/29/2012 15:17'!
noSourcesAvailable

	^ #NoSourcesAvailable! !

!PharoTrackerLabels class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/29/2012 15:17'!
reviewNeeded

	^ #FixReviewNeeded! !

!PharoTrackerLabels class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/30/2012 16:53'!
testFailure

	^ #FailingTest! !

!PharoTrackerLabels class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/29/2012 15:17'!
workNeeded

	^ #WorkNeeded! !

Object subclass: #SliceSubmitter
	instanceVariableNames: 'issue mcPackage receiver'
	classVariableNames: 'tracker'
	poolDictionaries: ''
	category: 'CI-Core-SliceSubmitter'!

!SliceSubmitter commentStamp: '<historical>' prior: 0!
SliceSubmitter is a tool made to submit slice easily be automaticcaly creating the issue on GoogleIssueTracker!

!SliceSubmitter class methodsFor: 'authentification' stamp: 'BenjaminVanRyseghem 7/4/2012 15:19'!
authenticate: user with: password 

	tracker := GoogleIssueTracker pharo.
	tracker authenticate: user with: password! !

!SliceSubmitter class methodsFor: 'nautilus menu' stamp: 'BenjaminVanRyseghem 7/10/2012 14:31'!
buildNautilusMenu: aBuilder
	<nautilusPackageMenu>
	| package target mc |
	target := aBuilder model.
	(package := target selectedPackage) ifNil: [ ^ self ].
	mc := NautilusMCBindings default retrieveMCPackageFor: package.
	
	mc workingCopy modified not ifTrue: [ ^ self ].
	(aBuilder item: #'Commit this package')
		action: [ self new 
						receiver: target window;
						mcPackage: mc;
						submitNewSlice ];
		order: 1299.5;
		icon: UITheme current forwardIcon;
		help: 'Create a bug entry and a slice for the selected package';
		withSeparatorAfter.
	! !

!SliceSubmitter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/6/2012 16:44'!
commit: workingCopy in: repo message: message
	| newVersion |

	[ newVersion := workingCopy newVersion ]
		on: MCVersionNameAndMessageRequest
		do: [:n | n resume: (Array with: n suggestedName with: message)].
		
	newVersion ifNil: [ ^ self ].
	repo storeVersion: newVersion.
	repo storeDependencies: newVersion! !

!SliceSubmitter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/6/2012 16:46'!
initialize
	"Initialization code for SliceSubmitter"

	super initialize.
		
	issue := GoogleIssue new
				status: PharoTrackerLabels accepted;
				tracker: self tracker;
				yourself.
	receiver := World.
	mcPackage := nil.! !

!SliceSubmitter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/6/2012 16:47'!
initializeTracker
	| userPassword tries |

	tries := 3.
	[ userPassword isNil and: [ tries > 0] ] whileTrue: [ 
		tries := tries -1.
		userPassword := self retrieveUserPassword ].
	[ self class authenticate: userPassword key with: userPassword value ] on: Error do: [ tracker := nil ].! !

!SliceSubmitter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 16:09'!
issue
	^ issue! !

!SliceSubmitter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 16:15'!
mcPackage

	^ mcPackage! !

!SliceSubmitter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 16:15'!
mcPackage: anObject

	mcPackage := anObject! !

!SliceSubmitter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/6/2012 16:45'!
postNewSlice: workingCopy message: aMessage

	workingCopy ifNil: [ ^ self ].
	self commit: workingCopy in: MCHttpRepository inboxRepository message: aMessage! !

!SliceSubmitter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 16:14'!
receiver

	^ receiver! !

!SliceSubmitter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 16:15'!
receiver: anObject

	receiver := anObject! !

!SliceSubmitter methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/6/2012 15:48'!
repository

	^ MCHttpRepository
			location: 'http://ss3.gemstone.com/ss/Pharo20'
			user: ''
			password: ''! !

!SliceSubmitter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/4/2012 15:11'!
retrieveUserPassword

	| ui user password |
	
	ui := Authentifier new.
	World openModal: ui openDialogWithSpec.
	^ ui result! !

!SliceSubmitter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 17:07'!
submitNewSlice
	| slice creator wc message |
	
	self tracker ifNil: [ ^ self ].
	self mcPackage ifNil: [ ^ self ].
	wc :=  self mcPackage workingCopy.
	wc modified ifFalse: [ ^ self ].
	
	(self viewChangesFor: wc)
		ifFalse: [ ^ self ].
	
	slice := MCSliceInfo new
				includedPackages: { wc };
				yourself.
				
	creator := IssueCreator new
					issue: issue;
					yourself.
	 
	self receiver openModal: creator openDialogWithSpec window.
	creator cancelled ifTrue: [ ^ self ].
	message := issue description content.
	issue description: (String streamContents: [:s |
								s << message.
								s cr; cr.
								s << '-------------------';cr.
								s<< 'Slice is in the inbox']).
	[ issue submitAsNewEntry ] on: ErrorWhileCreationException do: [ ^ self ].

	slice issueNumber: issue id asString.
	slice issueSummary: issue title.
	slice := slice makeSlice.
	
	self postNewSlice: slice message: message.
	
	issue
		status: PharoTrackerLabels reviewNeeded;
		submitStatusChange! !

!SliceSubmitter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/10/2012 14:02'!
tracker

	^ tracker ifNil: [ 
		self initializeTracker.
		tracker ].! !

!SliceSubmitter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/6/2012 16:21'!
viewChanges: patch for: workingCopy from: fromDescription to: toDescription
	"Open a browser on the given patch."
	| morph |

	morph := (PSMCPatchMorph forPatch: patch)
						fromDescription: fromDescription;
						toDescription: toDescription;
						vResizing: #spaceFill;
						hResizing: #spaceFill;
						yourself.
						
	^ MorphEmbedder new
			title: ('Changes to {1}' translated format: {fromDescription});
			morph: morph;
			yourself ! !

!SliceSubmitter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 17:07'!
viewChangesFor: workingCopy
	"View the changes made in the working copy."
	
	| patch |
	'Finding changes' displayProgressFrom: 0 to: 10 during:[:bar|
		bar current: 1.
		patch := workingCopy changesRelativeToRepository: self repository.
		patch isNil ifTrue: [^ self].
		bar current: 3.
		patch isEmpty
			ifTrue: [
				workingCopy modified: false.
				bar current: 10.
				self inform: 'No changes'.
				^ false ]
			ifFalse: [ | window |
				workingCopy modified: true.
				bar current: 5.
				
				window := self
					viewChanges: patch
					for: workingCopy
					from: workingCopy  packageName, ' (', workingCopy ancestry ancestorString, ')'
					to: ('Modified {1}' translated format: {workingCopy description}).
				self receiver openModal: window openDialogWithSpec window.
				^ window result ]]! !

Object subclass: #UlysseTheMonkey
	instanceVariableNames: 'tracker previousTestResult loadStopwatch testClasses testStopwatch extraTests errors testErrors testFailures testResult issue verbose'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core'!

!UlysseTheMonkey commentStamp: '<historical>' prior: 0!
A UlysseTheMonkey is an intergalactikal monkey who is coming from outer space to check the fix proposed in the google issue tracker.

Do NOT mess with Ulysse !!!!!

!UlysseTheMonkey class methodsFor: 'example' stamp: 'CamilloBruni 9/22/2011 19:47'!
example
	| tracker changeLoader issue |
	
	tracker := GoogleIssueTracker pharo.
	
	tracker authenticate: 'USERNAME@gmail.com' with: 'PASSWORD'.

	issue := tracker issue: 4839.
	
	changeLoader := issue load! !

!UlysseTheMonkey class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 9/21/2011 14:37'!
issue: issue

	^ self new
		issue: issue;
		yourself! !

!UlysseTheMonkey class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 9/21/2011 01:34'!
tracker: tracker

	^ self new
		tracker: tracker;
		yourself! !

!UlysseTheMonkey methodsFor: 'testing' stamp: 'CamilloBruni 9/22/2011 21:16'!
addError: anError
	
	^ self addError: anError forFile: nil! !

!UlysseTheMonkey methodsFor: 'testing' stamp: 'MonkeyGalactikalIntegrator 12/16/2011 16:56'!
addError: anError forFile: aFileNameString

	|index|
	
	index := 1.
	
	errors add:(String streamContents: [ :stream|
		aFileNameString ifNotNil: [ 
			stream << 'Error while loading ' << aFileNameString << ':'; lf].
		stream tab print: anError; lf.
		(anError signalerContext contextStack first: 10) do: [ :context|
			stream << (index asString padded: #left to: 2 with: $ ); << ':'; tab.
			"indent the error string"
			stream << (context asString copyReplaceAll: String cr with: String lf, String tab); lf.
			index := index + 1].
		stream tab << '...'])! !

!UlysseTheMonkey methodsFor: 'printing' stamp: 'CamilloBruni 1/20/2012 20:29'!
buildErrorReportOn: stream

	errors isEmpty ifTrue: [ ^ self ].
	
	stream nextPutAll: 'Monkey went bananas:'; lf.
	
	errors 
		do: [:e | 
			stream nextPutAll: '--------------------'; lf.
			stream nextPutAll: e ]
		separatedBy: [ stream lf lf]
			! !

!UlysseTheMonkey methodsFor: 'printing' stamp: 'CamilloBruni 9/30/2011 14:12'!
buildGreenChangesOn: aStream

	self flag: 'print the recorded changes '.! !

!UlysseTheMonkey methodsFor: 'printing' stamp: 'CamilloBruni 9/23/2011 15:38'!
buildGreenReport

	^ String streamContents: [:stream | self buildGreenReportOn: stream ]! !

!UlysseTheMonkey methodsFor: 'printing' stamp: 'CamilloBruni 9/30/2011 14:12'!
buildGreenReportOn: stream

	| packages |
	
	testResult ifNil: [ ^ self ].
	
	self buildGreenTitleOn: stream.
	self buildGreenTestResultsOn: stream.
	self buildGreenChangesOn: stream.
	self buildSetupDescriptionOn: stream.! !

!UlysseTheMonkey methodsFor: 'printing' stamp: 'MonkeyGalactikalIntegrator 1/25/2012 00:21'!
buildGreenTestResultsOn: stream
	|packages|
	
	"count the number of tests per package"
	packages := Dictionary new.
	testResult passed do: [ :testCase| | package |
		package := testCase class category.
		packages at: package put: (packages at: package ifAbsent: [ 0 ]) + 1 ].
	
	packages keys asArray sort do: [ :package|
		stream tab; nextPutAll: package; nextPutAll: ' ('; print: (packages at: package); nextPutAll: ')'; lf].
	
	stream lf.! !

!UlysseTheMonkey methodsFor: 'printing' stamp: 'CamilloBruni 1/20/2012 20:29'!
buildGreenTitleOn: aStream 
	|duration title|
	
	duration := testStopwatch duration.
	
	title :=  String streamContents: [ :s |
					s << testResult passed size asString << ' tests passed in '.
					s << (duration hours asString padded: #left to: 2 with: $0) << ':'.
					s << (duration minutes asString padded: #left to: 2 with: $0) << ':'.
					s << (duration seconds asString padded: #left to: 2 with: $0) << 's:'].
				
	aStream << title; lf.
	title size timesRepeat: [ aStream nextPutAll: '='].
	aStream lf.
	! !

!UlysseTheMonkey methodsFor: 'printing' stamp: 'CamilloBruni 9/23/2011 15:38'!
buildRedReport

	^ String streamContents: [:stream | self buildRedReportOn: stream ]! !

!UlysseTheMonkey methodsFor: 'printing' stamp: 'CamilloBruni 9/25/2011 05:06'!
buildRedReportOn: stream
	
	self buildErrorReportOn: stream.
	self buildTestsReportOn: stream.
	
	stream lf.
	self buildSetupDescriptionOn: stream.! !

!UlysseTheMonkey methodsFor: 'printing' stamp: 'CamilloBruni 1/20/2012 20:28'!
buildSetupDescriptionOn: aStream
	
	aStream nextPutAll: '----------------------------------------------------------'; lf.
	aStream nextPutAll: 'Loaded Source: '.
	
	self issue hasSlice ifTrue: [ 
		aStream 
			nextPutAll: self slice name;
			nextPutAll: ' from ';
			nextPutAll: self slice repository description ].
		
	self issue hasChangeSet
		ifTrue: [
			self issue changeSets size > 1 ifTrue: [ aStream lf tab ].
			self issue changeSets 
					do: [ :attachment|  aStream nextPutAll: attachment description ]
					separatedBy: [ aStream lf tab ]].
		
	aStream lf;
		nextPutAll: 'Tested using '; nextPutAll: SystemVersion current imageVersionString;
		nextPutAll: ' on '; nextPutAll: Smalltalk vm version! !

!UlysseTheMonkey methodsFor: 'printing' stamp: 'CAmilloBruni 7/19/2012 15:45'!
buildTestsReportOn: stream
	
	(testErrors isEmptyOrNil and: [ testFailures isEmptyOrNil])
		ifTrue: [ ^ self ].
	
	stream nextPutAll: 'Test Results:'; lf.
	stream nextPutAll: '-------------'; lf.
			
	stream nextPutAll: 'Passed: '; print: testResult passed size; lf.
	self buildGreenTestResultsOn: stream.
	
	testErrors ifNotEmpty: [:collection |
		stream nextPutAll: 'Errors: '; print: collection size; lf.
		collection do: [:e | stream tab print: e; lf ]].
	
	stream lf.
		
	testFailures ifNotEmpty: [:collection |
		stream nextPutAll: 'Failures: '; print: collection size; lf.
		collection do: [:e | stream tab print: e; lf ]]! !

!UlysseTheMonkey methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 7/2/2012 16:28'!
coreTests
	
	^ self class environment allClasses select: [:class | 
		{'SUnit'. 'CompilerTests'. 'CollectionsTests'. 'KernelTests'} 
			anySatisfy: [:packageName | 
				class category beginsWith: packageName ]].! !

!UlysseTheMonkey methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 9/26/2011 19:01'!
dirtyPackagesTests
				
	^ self issue dirtyPackagesTests! !

!UlysseTheMonkey methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 9/25/2011 17:07'!
errorNoLoadableSources
	
	"Error signal: 'Issue has no loadable sources attached'."
	
	self issue errorNoSources! !

!UlysseTheMonkey methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/22/2011 16:13'!
extraTests

	^ extraTests! !

!UlysseTheMonkey methodsFor: 'process' stamp: 'BenjaminVanRyseghem 9/21/2011 01:44'!
foundIssuesToCheck

	self tracker openIssues select: [:e | e hasToBeChecked ]! !

!UlysseTheMonkey methodsFor: 'private' stamp: 'BenjaminVanRyseghem 6/29/2012 15:28'!
ifGreen: greenBlock ifErrors: errorBlock ifTestFailing: testBlock

	self isGreen ifTrue: [ ^ greenBlock value ].

	^ errors isEmpty
		ifTrue: testBlock 
		ifFalse: errorBlock ! !

!UlysseTheMonkey methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 9/26/2011 18:27'!
impactedPackagesTests
			
	^ self issue impactedPackagesTests! !

!UlysseTheMonkey methodsFor: 'initialize' stamp: 'CamilloBruni 12/16/2011 13:15'!
initialize
	verbose := true.
	self reset.
	self retrieveTestClasses! !

!UlysseTheMonkey methodsFor: 'testing' stamp: 'CamilloBruni 9/23/2011 15:38'!
isAllGreen

	self runAllTests.
	^ testResult hasPassed! !

!UlysseTheMonkey methodsFor: 'testing' stamp: 'CamilloBruni 9/23/2011 16:43'!
isCog

	^ Smalltalk vm version includesSubString: 'Cog'! !

!UlysseTheMonkey methodsFor: 'testing' stamp: 'CamilloBruni 9/23/2011 16:19'!
isGreen
	^  errors isEmpty and: [ testFailures isEmptyOrNil and: [ testErrors isEmptyOrNil ]]! !

!UlysseTheMonkey methodsFor: 'accessing' stamp: 'CamilloBruni 12/16/2011 10:04'!
isVerbose
	^ verbose! !

!UlysseTheMonkey methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/21/2011 17:10'!
issue

	^ issue! !

!UlysseTheMonkey methodsFor: 'accessing' stamp: 'CamilloBruni 9/22/2011 13:53'!
issue: anIssue
	
	issue := anIssue.! !

!UlysseTheMonkey methodsFor: 'protocol' stamp: 'CamilloBruni 9/30/2011 18:32'!
load
	"simply load a slice or changesets associated with the issue.
	Note: this does NOT updae the issue tracker, see loadAndTest for this"
	
	self issue hasSlice ifTrue: [ ^ self loadSlice ].
	self issue hasChangeSet ifTrue: [ ^ self loadChangeSet ].

	"Here we assume the check has already be done by the issue"! !

!UlysseTheMonkey methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 9/25/2011 17:51'!
loadAndTest
	"load the changesets or the slice for the issue and run tests.
	Note this will update directly notify the issue tracker and add comments."
	
	self issue hasSlice ifTrue: [ ^ self loadAndTestSlice ].
	self issue hasChangeSet ifTrue: [ ^ self loadAndTestChangeSet ].
	
	"Here I assume the check have already been done by the issue itself"! !

!UlysseTheMonkey methodsFor: 'protocol' stamp: 'CamilloBruni 9/23/2011 15:27'!
loadAndTestChangeSet
	"load the changesets and run the test"
	
	self issue changeSets ifEmpty: [ ^ self ].
	
	self testChangeImpact: [ self loadChangeSet ].! !

!UlysseTheMonkey methodsFor: 'protocol' stamp: 'CamilloBruni 9/25/2011 05:04'!
loadAndTestSlice
	"Load slice and run tests"
	
	self issue hasSlice ifFalse: [ ^ self ].
	
	self testChangeImpact: [ self loadSlice ].
	! !

!UlysseTheMonkey methodsFor: 'private' stamp: 'CamilloBruni 9/30/2011 14:11'!
loadChangeSet
	"load the changeset(s) for the issue"
	
	self flag: 'TODO: record the adds/changes/removes per package'.
	
	self issue changeSets do: [ :attachment | 
		 [ attachment contents asString readStream fileIn ] 
			on: Error 
			do: [ :e| self addError: e forFile: attachment description ]].
		
	self extraTests addAll: self dirtyPackagesTests.! !

!UlysseTheMonkey methodsFor: 'private' stamp: 'CamilloBruni 8/8/2012 19:03'!
loadSlice
	"load the slice for the set issue"
	
	self flag: 'TODO: record the adds/changes/removes per package'.
	
	[ self slice merge ]
		on: Error, Warning
		do: [ :e| 
			self 
				addError: e 
				forFile: (self slice name, ' from ', self slice repository description)].! !

!UlysseTheMonkey methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/29/2012 15:26'!
notifyTracker
	self isVerbose ifFalse: [ ^ self ].
	
	self 
		ifGreen: [ self issue fixToInclude: self buildGreenReport ]
		ifErrors: [ self issue reviewNeeded: self buildRedReport ]
		ifTestFailing:[ self issue failingTest: self buildRedReport ]! !

!UlysseTheMonkey methodsFor: 'testing' stamp: 'CamilloBruni 9/22/2011 09:41'!
preRunTests
	
	" I run tests a first time to be able to remove false errors later"
	previousTestResult := self runTests.! !

!UlysseTheMonkey methodsFor: 'accessing' stamp: 'CamilloBruni 12/16/2011 10:04'!
quiet
	verbose := false! !

!UlysseTheMonkey methodsFor: 'testing' stamp: 'CamilloBruni 9/25/2011 03:54'!
removeCriticalTestsFrom: aTestSuite
	
	{
		MethodContextTest>>#testClosureRestart. 
		AllocationTest>>#testOneGigAllocation.
		SizeInMemoryTest>>#testSizeInMemoryClasses
	} do: [ :method|
		(aTestSuite tests
				detect: [ :testCase| 
						testCase class = method methodClass and: [ testCase selector = method selector ]] 
				ifNone: [ nil ])
			ifNotNil: [:testCase| aTestSuite tests remove: testCase ]].
	
	^ aTestSuite! !

!UlysseTheMonkey methodsFor: 'testing' stamp: 'CamilloBruni 9/22/2011 19:29'!
removeFalseErrors

	testFailures := #().
	testErrors := #().
	testResult ifNil: [ ^ self ].
	
	testFailures := testResult failures reject:[: each || detected |
		detected := previousTestResult failures detect: [:e2 | each name = e2 name ] ifNone: [nil].
		detected ifNil: [ false ] ifNotNil: [ each selector = detected selector ]].
	
	
	testErrors := testResult errors reject:[: each || detected |
		detected := previousTestResult errors detect: [:e2 | each name = e2 name ] ifNone: [nil].
		detected ifNil: [ false ] ifNotNil: [ each selector = detected selector ]].
	! !

!UlysseTheMonkey methodsFor: 'initialize' stamp: 'CamilloBruni 9/23/2011 15:36'!
reset
	
	errors := Set new.
	extraTests := Set new.
	loadStopwatch := Stopwatch new.
	testStopwatch := Stopwatch new.! !

!UlysseTheMonkey methodsFor: 'initialize' stamp: 'CamilloBruni 9/23/2011 16:21'!
retrieveTestClasses

	testClasses := OrderedCollection new.	
	
	testClasses addAll: self coreTests.
	testClasses := testClasses select: [:e | 
						(e inheritsFrom: TestCase) and: [ e isAbstract not ]].! !

!UlysseTheMonkey methodsFor: 'testing' stamp: 'CamilloBruni 9/22/2011 14:22'!
runAllTests
	
	|suite|
	
	suite := TestSuite new.
	
	TestCase allSubclasses do: [ :testClass|
		testClass isAbstract ifFalse: [ suite addTests: testClass suite tests ]].
	
	testResult := suite run.! !

!UlysseTheMonkey methodsFor: 'testing' stamp: 'MonkeyGalactikalIntegrator 10/2/2011 18:27'!
runTests

	| suite result |
	
	suite := TestSuite new.
	
	testClasses do: [ :testClass|
		suite addTests: testClass suite tests ].
	
	suite := self removeCriticalTestsFrom: suite.

	self extraTests do: [ :testClass|
		suite addTests: testClass suite tests ].
	
	
	testStopwatch reset activate.
	result := suite run.
	testStopwatch suspend.
	
	^ result! !

!UlysseTheMonkey methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/25/2011 02:36'!
slice

	^ self issue slice! !

!UlysseTheMonkey methodsFor: 'testing' stamp: 'CamilloBruni 12/16/2011 10:05'!
testChangeImpact: aBlock
	| complete |
	
	"run the issue update requests in the background to save some time"
	complete := Semaphore new.
	[self isVerbose ifTrue: [ self issue monkeyIsChecking ].
	 complete signal ] fork.
	
	" I run tests a first time to be able to remove false errors later"
	self issue hasSlice
		ifTrue: [	self extraTests addAll: self impactedPackagesTests ].
			
	self preRunTests.
	[
		loadStopwatch reset activate.
		"here I load the code"
		aBlock value.
		loadStopwatch suspend.

		"Then I re run tests"
		testResult := self runTests.
		self removeFalseErrors.
		
	"collect possible errors"
	] on: Error do: [ :e| self addError: e ].
	
	"wait for the initial issue update to be completed"
	complete wait.
	"update the issue with load/test results"
	self notifyTracker.! !

!UlysseTheMonkey methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 9/26/2011 18:38'!
testClassesToBeChecked

	^ self issue testClassesToBeChecked! !

!UlysseTheMonkey methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/21/2011 17:10'!
testResult

	^ testResult! !

!UlysseTheMonkey methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/21/2011 17:10'!
testResult: anObject

	testResult := anObject! !

!UlysseTheMonkey methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/21/2011 01:34'!
tracker: anObject
	
	tracker := anObject! !

!UlysseTheMonkey methodsFor: 'accessing' stamp: 'CamilloBruni 12/16/2011 10:04'!
verbose
	verbose := true! !

!String methodsFor: '*CI-Core' stamp: 'Integrator 6/21/2012 18:03'!
asGoogleIssueComment
	^ GoogleIssueComment new
		content: self;
		author: (GoogleUser email: Author fullName);	
		yourself! !

!String methodsFor: '*CI-Core' stamp: 'Integrator 6/21/2012 18:03'!
asGoogleIssueDescription
	^ self asGoogleIssueComment asDescription! !
